------------------------------------------------------------------------------
-------------- Code from Crickets Complication mod ---------------------------
------------------------------------------------------------------------------
function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;

	self.lifetimer = Timer();

	if globalhneedlerlist == nil then
		globalhneedlerlist = {};
	end
	self.listnum = #globalhneedlerlist + 1;
	globalhneedlerlist[self.listnum] = self;

	self.stickpositionX = 0;
	self.stickpositionY = 0;
	self.stickrotation = 0;
	self.stickdirection = 0;

	self.sticktarget = nil;
	self.stuck = false;

	self.idlefloattime = 5000;
	self.idlesticktime = 1500;

	self.curdist = 15;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "Torque Bow" and gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,gun.Pos,self.mapwrapx).Magnitude < self.curdist then
			actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) then
				self.parent = ToActor(actor);
				self.parentgun = ToHDFirearm(gun);

				if math.random(1,2) == 2 then
					self.negatore = -1;
				else
					self.negatore = 1;
				end

				self.negatore = nil;

				break;
			end
		end
	end

end

function Update(self)

	if self.stuck == false then

		if self.lifetimer:IsPastSimMS(self.idlefloattime) == true then
			self:GibThis();
		end

		if self.target ~= nil and self.target.ID ~= 255 then
			self.RotAngle = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx).AbsRadAngle;
		end

		self.stickobject = SceneMan:CastMORay(self.Pos,Vector(5,0):RadRotate(self.RotAngle),-1,self.Team,0,false,0);
		self.clingpos = Vector(0,0);

		if self.stickobject ~= 255 then
			self.sticktarget = MovableMan:GetMOFromID(self.stickobject);
			self.stickpositionX = self.Pos.X-self.sticktarget.Pos.X;
			self.stickpositionY = self.Pos.Y-self.sticktarget.Pos.Y;
			self.stickrotation = self.sticktarget.RotAngle;
			self.stickdirection = self.RotAngle;
			self.startflipped = self.sticktarget.HFlipped;
			self.stuck = true;
			self.lifetimer:Reset();
		elseif SceneMan:CastStrengthRay(self.Pos,Vector(12,0):RadRotate(self.Vel.AbsRadAngle),0,self.clingpos,0,0,self.mapwrapx) == true then
			self.Vel = Vector(0,0);
			self.PinStrength = 1000;
			self.Pos = self.clingpos;
			self.stuck = true;
			self.lifetimer:Reset();
		end

	else

		if self.lifetimer:IsPastSimMS(self.idlesticktime) == true then
			self:GibThis();
		end

		if self.sticktarget ~= nil and self.sticktarget.ID ~= 255 then
			self.ToDelete = false;
			self.ToSettle = false;
			self.Pos = self.sticktarget.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.sticktarget.RotAngle-self.stickrotation);
			self.RotAngle = self.stickdirection+(self.sticktarget.RotAngle-self.stickrotation);
			self.Vel = Vector(0,0);
			self.PinStrength = 1000;
			self.Mass = self.sticktarget.RootID;
			if self.Sharpness == 1 then
				self:GibThis();
			end
			if self.lifetimer:IsPastSimMS(self.idlesticktime) == true then
				for i = 1, #globalhneedlerlist do
					if MovableMan:IsParticle(globalhneedlerlist[i]) == true and globalhneedlerlist[i].Mass == self.Mass then
						globalhneedlerlist[i].Sharpness = 1;
					end
				end
				self:GibThis();
			end
		elseif self.sticktarget ~= nil and self.sticktarget.ID == 255 then
			self:GibThis();
		end

	end

end

function Destroy(self)

	globalhneedlerlist[self.listnum] = nil;

end