--------------------------------------------------
-------------- VANILLA ---------------------------
--------------------------------------------------
function Create(self)

	self.fireTimer = Timer();
	self.chargeTimer = Timer();
	self.effectTimer = Timer();
	self.fireOn = false;

	self.particleTable = {};
	self.glowCount = 0;
	self.chargeCounter = 0;

	self.glowChargeIncrement = 0.2;
	self.maxCharge = 40;
	self.chargesPerSecond = 20;

end

function Update(self)
    
	if self:IsActivated() then

		if self.glowCount < 5 and self.chargeCounter >= self.maxCharge*(self.glowChargeIncrement*self.glowCount) then
			self.glowCount = self.glowCount + 0.3;
			local effectPar = CreateMOPixel("Torque Bow Glow");
			effectPar.Pos = self.MuzzlePos;
			effectPar.PinStrength = 1000;
			MovableMan:AddParticle(effectPar);
			self.particleTable[#self.particleTable+1] = effectPar;
		end

		if self.chargeCounter <= self.maxCharge then
			self.chargeCounter = math.min(self.chargeCounter + ((self.chargeTimer.ElapsedSimTimeMS/1000)*self.chargesPerSecond),self.maxCharge);
			self.chargeTimer:Reset();
		end

		for i = 1, #self.particleTable do
			if MovableMan:IsParticle(self.particleTable[i]) then
				self.particleTable[i].ToDelete = false;
				self.particleTable[i].ToSettle = false;
				self.particleTable[i].PinStrength = 1000;
				self.particleTable[i].Pos = self.MuzzlePos;
			end
		end

	else

		if self.chargeCounter > 0 then
			if self.HFlipped == false then
				self.reverseNum = 1;
			else
				self.reverseNum = -1;
			end

			local actor = MovableMan:GetMOFromID(self.RootID);

			self.particleTable = {};
			self.chargeCounter = 0;
			self.glowCount = 0;
		end

		for i = 1, #self.particleTable do
			if MovableMan:IsParticle(self.particleTable[i]) then
				self.particleTable[i].ToDelete = true;
			end
		end
		self.fireTimer:Reset();
		self.particleTable = {};
	end

end

function Destroy(self)

	for i = 1, #self.particleTable do
		if MovableMan:IsParticle(self.particleTable[i]) then
			self.particleTable[i].ToDelete = true;
		end
	end

end